unit RleDecompression;
// code dcompression RLE

(*
 TPE 2001-2002
 DODANE Jean-Baptiste, ROUSSILLON Cyril  TS3
 Lyce Xavier Marmier, PONTARLIER

 Pour toute question, vous pouvez nous contacter :
   Jean-Baptiste (LZW, RLE) : jb@jbdsoftware.fr.st
   Cyril (JPEG, prdictif)  : cyril@crtek.fr.st
   
 Les TPE complets sont disponibles  l'adresse :
   www.chez.com/itek
 Ou sur nos sites personnels :
   www.jbdsoftware.fr.st
   www.crteknologies.fr.st
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Buttons, _bibliotheque;

type
  TForm4 = class(TForm)
    GBDecompression: TGroupBox;
    BtnDecompress: TButton;
    BtnOpen: TButton;
    BtnSave: TButton;
    ODialog: TOpenDialog;
    SDialog: TSaveDialog;
    GBImageInfo: TGroupBox;
    LabelN: TLabel;
    LabelT: TLabel;
    LabelH: TLabel;
    LabelL: TLabel;
    LabelC: TLabel;
    ProgressBar: TProgressBar;
    BtnSee: TBitBtn;
    LabelNv: TLabel;
    LabelHv: TLabel;
    LabelLv: TLabel;
    LabelTv: TLabel;
    LabelCv: TLabel;

    Procedure ResetAll2;
    Procedure Redessiner2;
    Procedure LoadInformations(Total : Boolean);
    procedure BtnOpenClick(Sender: TObject);
    procedure BtnDecompressClick(Sender: TObject);
    procedure BtnSaveClick(Sender: TObject);
    procedure BtnSeeClick(Sender: TObject);
  private
    Function PixGrid2BMP(Image : PixGrid ; Filename : String) : Boolean;
  public
    { Dclarations publiques }
  end;

var
  Form4: TForm4;
  FichierEnCours : String;
  FileHandle : Integer;

implementation

uses RleCompression, RleVisualisation;

{$R *.DFM}

Var   TRLEEnCours : TRLE;
      ImageDEncours : PixGrid;


procedure TForm4.BtnOpenClick(Sender: TObject);
begin
If ODialog.Execute then LoadInformations(False);
end;

Procedure TForm4.LoadInformations(Total : Boolean);
Begin
TRLEEnCours := Form1.MakeTRLE(ODialog.Filename);
If TRLEEnCours.Nature = 00 then Form1.ErrorMessage('Le fichier n''a pas t compress correctement') else BtnDecompress.Enabled := True;

Form4.LabelNv.Caption := ExtractFileName(ODialog.Filename);
LabelHv.Caption := IntToStr(TRLEEnCours.Height);
LabelLv.Caption := IntToStr(TRLEEnCours.Width);
LabelTv.Caption := IntToStr(TRLEEnCours.Size + 12);
LabelCv.Caption := IntToStr(TRLEEnCours.Colors);

If Total then Begin
              Form4.BtnDecompress.Click;
              End;
End;

procedure TForm4.BtnDecompressClick(Sender: TObject);
begin
 Case TRLEEnCours.Nature of
 00 : Begin Form1.ErrorMessage('Erreur dans la compression du fichier'); Exit; End;
 01 : ImageDEnCours := Form1.ELRHorz(TRLEEnCours);
 02 : ImageDEnCours := Form1.ELRVert(TRLEEnCours);
 End;

If ImageDEnCours <> Nil then BEGIN
Form5.ClientHeight := TRLEEnCours.Height + 10;
Form5.ClientWidth := TRLEEnCours.Width + 10;

Form5.Show;
Redessiner2;
BtnSave.Enabled := True;
BtnSee.Enabled := True;

                            END;


end;

Procedure TForm4.Redessiner2;
Var i, j : Integer;
Begin
Form5.Refresh;
Form5.ClientHeight := TRLEEnCours.Height + 10;
Form5.ClientWidth := TRLEEnCours.Width + 10;

For i := 0 to (TRLEEnCours.Height - 1) do
    For j := 0 to (TRLEEnCours.Width - 1) do
        Form5.Canvas.Pixels[j+5, i+5] := ImageDEnCours[j, i];
End;

Procedure TForm4.ResetAll2;
Begin
LabelNv.Caption := '???';
LabelHv.Caption := '???';
LabelLv.Caption := '???';
LabelTv.Caption := '???';
LabelCv.Caption := '???';
ProgressBar.Position := 0;
End;

Function TForm4.PixGrid2BMP(Image : PixGrid ; Filename : String) : Boolean;
Var
  FileHandle, i, j, k, Written: Integer;
  Buffer: Array[0..998] Of Byte;
  Couleur: TColor;
  TmpC: Integer;
  TmpW: Word;

Const Stop : Integer = 999;

Begin
  FileHandle := FileCreate(Filename);
  Try
         FileWrite(FileHandle, 'BM', 2);      // Signature : 'BM'                               (2)
    TmpC := (TRLEEnCours.Width * TRLEEnCours.Height * 3) + 54;
         FileWrite(FileHandle, TmpC, 4);   // Taille du fichier entier                       (6)
    TmpC := 0;
         FileWrite(FileHandle, TmpC, 4);   // 4 x '0' => Obligatoire                         (10)
    TmpC := 54;
         FileWrite(FileHandle, TmpC, 4);   // Offset de l'image : A partir de 54 (Taille de l'en-tte)      (14)
    TmpC := 40;
         FileWrite(FileHandle, TmpC, 4);   // Taille de l'entte restant : Donc 54 (Header total) - 14 (Header dja crit) = (18)
         FileWrite(FileHandle, TRLEEnCours.Width, 4);   // Largeur et                          (22)
         FileWrite(FileHandle, TRLEEnCours.Height, 4);  // Hauteur                             (26)
    TmpW := 1;
         FileWrite(FileHandle, TmpW, 2);                //Nombre de plans => 1 obligatoire      (28)
    TmpW := 24;
         FileWrite(FileHandle, TmpW, 2);                //Bits par pixels : Bien sr 24 bits    (30)
    TmpC := 0;
         FileWrite(FileHandle, TmpC, 4);                // Mthode de compression : 0 = Uncompressed.    (34)
    TmpC := TRLEEnCours.Width * TRLEEnCours.Height * 3;
         FileWrite(FileHandle, TmpC, 4);                // Taille de l'image en octets           (38)
    TmpC := 3790;
         FileWrite(FileHandle, TmpC, 4);                //Rsolution Horizontale : 3790 pix/m    (42)
    TmpC := 3780;                                       // Ces 2 valeurs d'aprs MS Paint  
         FileWrite(FileHandle, TmpC, 4);                //           Verticale : 3780 pix/m      (46)
    TmpC := 0;
         FileWrite(FileHandle, TmpC, 4);                //Palette : 0, car 24 Bits                (50)
         FileWrite(FileHandle, TmpC, 4);                //Masque : Aucune ncssit               (54)

    i := 0;          // Initialisation des variables
    j := 0;

    Repeat
    Written := 0;
      For k := 1 To Stop DIV 3 Do
      Begin
        Couleur := Image[j, (TRLEEnCours.Height - i - 1)];
        Buffer[(i * TRLEEnCours.Width * 3 + j * 3 + 0) Mod Stop] := GetBValue(Couleur);
        Buffer[(i * TRLEEnCours.Width * 3 + j * 3 + 1) Mod Stop] := GetGValue(Couleur);
        Buffer[(i * TRLEEnCours.Width * 3 + j * 3 + 2) Mod Stop] := GetRValue(Couleur);

       	Inc(j);
        Inc(Written, 3);

        If j >= TRLEEnCours.Width Then Begin j := 0; Inc(i) End;
        If i >= TRLEEnCours.Height Then Break;
      End;

      FileWrite(FileHandle, Buffer, Written);

    Until i = TRLEEnCours.Height;

  Finally Begin FileClose(FileHandle); Result := True; End; End;

End;

procedure TForm4.BtnSaveClick(Sender: TObject);
begin
If SDialog.Execute then Begin
                        If Copy(SDialog.Filename, Length(SDialog.Filename) - 3, 4) <> '.bmp' then SDialog.Filename := SDialog.Filename + '.bmp';
                        If PixGrid2BMP(ImageDEnCours, SDialog.Filename) then MessageDLG('Le fichier de sortie a t cr avec succs', mtInformation, [mbOK], 0);
                        End;
end;


procedure TForm4.BtnSeeClick(Sender: TObject);
begin
Form5.Show;
end;

end.
