unit _Bibliotheque;
// gestion bmp, huffman, gestion bits

(*
 TPE 2001-2002
 DODANE Jean-Baptiste, ROUSSILLON Cyril  TS3
 Lyce Xavier Marmier, PONTARLIER

 Pour toute question, vous pouvez nous contacter :
   Jean-Baptiste (LZW, RLE) : jb@jbdsoftware.fr.st
   Cyril (JPEG, prdictif)  : cyril@crtek.fr.st
   
 Les TPE complets sont disponibles  l'adresse :
   www.chez.com/itek
 Ou sur nos sites personnels :
   www.jbdsoftware.fr.st
   www.crteknologies.fr.st
*)

Interface

Uses
	Windows, Graphics, SysUtils, Dialogs, Math;

Procedure ErrorMessage(Info : String);

Type
	Erreur = Class End;
	Tab8x8 = Array[0..7, 0..7] Of Integer;
  Tab2D = Array Of Array Of TColor;
  PixGrid = Array Of Array Of TColor;

  sImage = Record
  	Pix: Array Of Array Of TColor;
    Largeur, Hauteur: Integer;
    nbCouleurs, Palette: Integer;
  End;

  CDCType = record
         Compression : Boolean;
         Packs : Integer;
         ProgressBar : Boolean;
         Messages : Boolean;
         File1, File2 : AnsiString;
         FileSize : Integer;
         FileType : String;
         FileDico : Integer;
         StartTime : TDateTime;
         EndTime : TDateTime;
         CalcTime : Integer;
         Ratio : Integer;
         end;



  sFichier = Record
    Nom, Format: String;
    Taille: Integer;
    AutreT, AutreC: Array[0..1] Of String;
  End;
  pFichier = ^sFichier;

  sNoeud = Record
  	ndFils: Array[0..1] Of Word;
    ndPere: Word;
    Code: Byte;
    Poids: Cardinal;
  End;

  sHuffman = Class
  	Public
	    nbCar, Taille: Integer;
	  	Nds: Array Of sNoeud;
	    Constructor Create(nbCaracteres: Integer);
			Procedure Actualiser;
			Procedure EcrireCar(Car: Integer; Var Offset: Integer; Var Dest: Array Of Byte);
			Function LireCar(Var Offset: Integer; Var Source: Array Of Byte): Integer;
    Private
			Procedure Donner2PlusPetits(Max: Integer; Var Result: Array Of Word);
  End;

  TProgressEvent = Procedure(Progression: Integer);

  Procedure EcrireBits(Valeur, Taille: Integer; Var Offset: Integer; Var Dest);
	Function LireBits(Taille: Cardinal; Var Offset: Integer; Var Source): Integer;
  Procedure SauverBMP(NomFichier: String; Var Img: sImage; Progress: TProgressEvent);
	Procedure ChargerAllBMP(NomFichier: String; Var Img: sImage; Progress: TProgressEvent; Fichier: pFichier);
        Procedure ChargerAllBMP2(NomFichier: String; Var iecBmpH, iecBmpW, iecSize, iecNbC : Integer; Var Image : PixGrid);
	Procedure Afficher(Var Image: sImage; Canevas: TCanvas; Progress: TProgressEvent);
	Function EQM(Var Image1, Image2: sImage): Integer;

Implementation


// LireInt
Function LireInt(Buffer: Array Of Byte; Offset: Integer; NbOctets: Integer): Integer;
Var i, Coeff: Integer;
Begin
	Coeff := 1; Result := 0;
	For i := Offset To Offset + NbOctets - 1 Do
  Begin
	  Result := Result + Buffer[i] * Coeff;
    Coeff := Coeff * 256;
  End;
End;


// EQM
Function EQM(Var Image1, Image2: sImage): Integer;
Var
  i, j: Integer;
  R: Int64;
Begin
  If (Image1.Largeur <> Image2.Largeur) Or
     (Image1.Hauteur <> Image2.Hauteur) Then
    Begin Result := -1; Exit End;
  R := 0;
  For i := 0 To Image1.Largeur - 1 Do For j := 0 To Image1.Hauteur - 1 Do
  Begin
    Inc(R, Sqr((GetRValue(Image1.Pix[i, j])) - GetRValue(Image2.Pix[i, j])));
    Inc(R, Sqr((GetRValue(Image1.Pix[i, j])) - GetRValue(Image2.Pix[i, j])));
    Inc(R, Sqr((GetRValue(Image1.Pix[i, j])) - GetRValue(Image2.Pix[i, j])));
  End;
  R := Round(R / (Image1.Largeur * Image1.Largeur * 3));
  Result := R;
End;

//---------------------------------------------------------------------------------------------
// Ecriture bits

// LireBit
Function LireBit(Var Source; Offset: Integer): Byte;
Var
	Adresse: ^Byte;
  Octet: Byte;
Begin
	Adresse := @Source;
  Inc(Adresse, Offset Div 8);
  Octet := Adresse^;
  Octet := Octet And (128 shr (Offset Mod 8));
	If Octet = 0 Then Result := 0 Else Result := 1;
End;

// EcrireBit
Procedure EcrireBit(Valeur: Byte; Var Dest; Offset: Integer);
Var
	Adresse: ^Byte;
  Octet: Byte;
Begin
	Adresse := @Dest;
  Inc(Adresse, Offset Div 8);
  Octet := Adresse^;
	If Valeur = 0 Then
    Octet := Octet And (not(128 shr (Offset Mod 8))) Else
    Octet := Octet Or (128 shr (Offset Mod 8));
  Adresse^ := Octet;
End;

//---------------------------------------------------------------------------------------------
// EcrireBits - Ecrit l'entier 'Valeur' sur 'Taille' bits dans 'Dest'  la position 'Offset'
Procedure EcrireBits(Valeur, Taille: Integer; Var Offset: Integer; Var Dest);
Var
	i: Integer;
  Buffer: Array[0..3] Of Byte;
  Tmp: Byte;
Begin
  Buffer[0] := 0; Buffer[1] := 0; Buffer[2] := 0; Buffer[3] := 0;
	Move(Valeur, Buffer, 4);
  Tmp := Buffer[3]; Buffer[3] := Buffer[0]; Buffer[0] := Tmp;
  Tmp := Buffer[2]; Buffer[2] := Buffer[1]; Buffer[1] := Tmp;
	For i := 32 - Taille To 31 Do
  Begin
  	EcrireBit(LireBit(Buffer, i), Dest, Offset);
    Inc(Offset);
  End;
End;

//---------------------------------------------------------------------------------------------
// LireBits - Renvoie la valeur de 'Taille' bits dans 'Source'  la position 'Offset'
Function LireBits(Taille: Cardinal; Var Offset: Integer; Var Source): Integer;
Var
	i: Integer;
  Buffer: Array[0..3] Of Byte;
  Tmp: Byte;
Begin
  Buffer[0] := 0; Buffer[1] := 0; Buffer[2] := 0; Buffer[3] := 0;
	For i := 32 - Taille To 31 Do
  Begin
	 	EcrireBit(LireBit(Source, Offset), Buffer, i);
    Inc(Offset);
  End;
  Tmp := Buffer[3]; Buffer[3] := Buffer[0]; Buffer[0] := Tmp;
  Tmp := Buffer[2]; Buffer[2] := Buffer[1]; Buffer[1] := Tmp;
	Move(Buffer, Result, 4);
End;

// Dessine 'Image' sur 'Canevas'
Procedure Afficher(Var Image: sImage; Canevas: TCanvas; Progress: TProgressEvent);
Var i, j: Integer;
Begin
	For i := 0 To Image.Largeur - 1 Do
  Begin
  	If @Progress <> nil Then Progress(Round(i * 100 / Image.Largeur));
  	For j := 0 To Image.Hauteur - 1 Do Canevas.Pixels[i, j] := Image.Pix[i, j];
  End;
End;

//*********************************************************************************************
// Huffman
//*********************************************************************************************

// Create
Constructor sHuffman.Create(nbCaracteres: Integer);
Var i: Integer;
Begin
	nbCar := nbCaracteres;
  Taille := nbCar * 2 - 1;
  SetLength(Nds, Taille);
  For i := 0 To Taille - 1 Do Nds[i].Poids := 0;
End;

// Donner2PlusPetits
Procedure sHuffman.Donner2PlusPetits(Max: Integer; Var Result: Array Of Word);
Var
	i: Integer;
  Grand: ^Word;
Begin
	For i := 0 To Max Do If Nds[i].Code = 3 Then Begin Result[0] := i; Break End;
  For i := i + 1 To Max Do If Nds[i].Code = 3 Then Begin Result[1] := i; Break End;
  If Nds[Result[0]].Poids > Nds[Result[1]].Poids Then Grand := @Result[0] Else Grand := @Result[1];
  For i := i + 1 To Max Do
    If (Nds[i].Code = 3) And (Nds[i].Poids < Nds[Grand^].Poids) Then
    Begin
    	Grand^ := i;
		  If Nds[Result[0]].Poids > Nds[Result[1]].Poids Then Grand := @Result[0] Else Grand := @Result[1];
    End;
  If Result[0] > Result[1] Then Begin i := Result[0]; Result[0] := Result[1]; Result[1] := i End
End;

// ConstruireArbre
Procedure sHuffman.Actualiser;
Var
	i: Integer;
  Petits: Array[0..1] Of Word;
Begin
  For i := 0 To nbCar - 1 Do Begin Nds[i].ndFils[0] := i; Nds[i].ndFils[1] := Taille End;
  For i := 0 To Taille - 1 Do Nds[i].Code := 3;
  For i := nbCar To Taille - 1 Do
  Begin
    Donner2PlusPetits(i - 1, Petits);
    Nds[i].Poids := Nds[Petits[0]].Poids + Nds[Petits[1]].Poids;
    Nds[i].ndFils[0] := Petits[0];
    Nds[i].ndFils[1] := Petits[1];
    Nds[Petits[0]].ndPere := i;
    Nds[Petits[1]].ndPere := i;
    Nds[Petits[0]].Code := 0;
    Nds[Petits[1]].Code := 1;
  End;
  Nds[Taille - 1].ndPere := Taille;
End;

//---------------------------------------------------------------------------------------------
// EcrireCar - Ecrit le caractre 'Car' (compress huffman) dans 'Dest'  la position 'Offset'
Procedure sHuffman.EcrireCar(Car: Integer; Var Offset: Integer; Var Dest: Array Of Byte);
Var
	i, n: Integer;
  Buffer: Array[0..9] Of Byte;
Begin
	If Car < 0 Then Car := 0 Else If Car > nbCar - 1 Then Car := nbCar - 1;
  Inc(Nds[Car].Poids);
  n := 0;
  Repeat
  	EcrireBit(Nds[Car].Code, Buffer, n);
    Inc(n);
    Car := Nds[Car].ndPere;
	Until Car = Taille - 1;
 	For i := n - 1 DownTo 0 Do
  Begin
  	EcrireBit(LireBit(Buffer, i), Dest, Offset);
    Inc(Offset);
  End;
End;

//---------------------------------------------------------------------------------------------
// LireCar - Renvoie le caractre (dcompress huffman) de 'Dest'  la position 'Offset'
Function sHuffman.LireCar(Var Offset: Integer; Var Source: Array Of Byte): Integer;
Var
	Pos, Bit: Integer;
Begin
	Pos := Taille - 1;
  Repeat
  	Bit := LireBit(Source, Offset);
    Pos := Nds[Pos].ndFils[Bit];
    Inc(Offset);
	Until Nds[Pos].ndFils[1] = Taille;
  Bit := Nds[Pos].ndFils[0];
  Inc(Nds[Bit].Poids);
  Result := Bit;
End;


//*********************************************************************************************
// Accs fichiers bitmaps BMP
//*********************************************************************************************

//---------------------------------------------------------------------------------------------
// ChargerBMP
// only for bitmaps 24bits and size multiple of 4 (see ChargerAllBMP for others)
Procedure ChargerBMP(NomFichier: String; Var Img: sImage);
Const
	Passe: Integer = 1023;
Var
  BMP_HeaderSize: Integer;
  TailleF, HandleF, i, j, k, TailleLu: Integer;
  Buffer: Array[0..1022] Of Byte;
  Couleur: TColor;
Begin
  HandleF := FileOpen(NomFichier, fmOpenRead);
  Try Try
    TailleF := FileSeek(HandleF, 0, 2);
    FileSeek(HandleF, 0, 0);

    FileRead(HandleF, Buffer, 14);
    If (Buffer[0] <> Ord('B')) Or (Buffer[1] <> Ord('M')) Then Raise Erreur(Erreur);
    If (LireInt(Buffer, 2, 4) <> TailleF) Then Raise ERangeError.Create('');
    If (LireInt(Buffer, 6, 4) <> 0) Then Raise ERangeError.Create('');
    FileRead(HandleF, BMP_HeaderSize, 4);
    FileRead(HandleF, Img.Largeur, 4);
    FileRead(HandleF, Img.Hauteur, 4);
    FileRead(HandleF, Buffer, BMP_HeaderSize - 12);
    If LireInt(Buffer, 0, 2) <> 1 Then Raise ERangeError.Create('');
    If LireInt(Buffer, 2, 2) <> 24 Then Raise ERangeError.Create('');
    If LireInt(Buffer, 4, 4) <> 0 Then Raise ERangeError.Create('');
    If LireInt(Buffer, 8, 4) <> (Img.Largeur * Img.Hauteur * 3) Then Raise ERangeError.Create('');
    SetLength(Img.Pix, Img.Largeur, Img.Hauteur);
    i := 0; j := 0;
    Repeat
      TailleLu := FileRead(HandleF, Buffer, Passe);
      For k := 1 To TailleLu div 3 Do
      Begin
        Couleur := RGB(Buffer[(i * Img.Largeur * 3 + j * 3 + 2) Mod Passe],
							         Buffer[(i * Img.Largeur * 3 + j * 3 + 1) Mod Passe],
						           Buffer[(i * Img.Largeur * 3 + j * 3 + 0) Mod Passe]);
        Img.Pix[j, Img.Hauteur - i -1] := Couleur;

       	Inc(j);
        If j >= Img.Largeur Then Begin j := 0; Inc(i) End;
        If i >= Img.Hauteur Then Break;
      End;
    Until TailleLu <> Passe;
  Except
  	On Erreur Do ShowMessage('Ce n''est pas le bon type de fichier');
    Else ShowMessage('Il s''est produit une erreur');
  End;
  Finally FileClose(HandleF) End;
  Img.nbCouleurs := 16777216;
  Img.Palette := 0;
End;

//---------------------------------------------------------------------------------------------
// SauverBMP
// only bitmap 24bits and size multiple of 4
Procedure SauverBMP(NomFichier: String; Var Img: sImage; Progress: TProgressEvent);
Const
	Passe: Integer = 1023;
Var
  BMP_HeaderSize: Integer;
  HandleF, i, j, k, tailleEcrit, Larg: Integer;
  Buffer: Array[0..1022] Of Byte;
  Couleur: TColor;
  TmpC: Cardinal;
  TmpW: Word;
Begin
  HandleF := FileCreate(NomFichier);
  Try
    FileWrite(HandleF, 'BM', 2);
    TmpC := Img.Largeur * Img.Hauteur * 3 + 54; FileWrite(HandleF, TmpC, 4);
    TmpC := 0; FileWrite(HandleF, TmpC, 4);
    TmpC := 54; FileWrite(HandleF, TmpC, 4);
    BMP_HeaderSize := 40;
    FileWrite(HandleF, BMP_HeaderSize, 4);
    FileWrite(HandleF, Img.Largeur, 4);
    FileWrite(HandleF, Img.Hauteur, 4);
    TmpW := 1; FileWrite(HandleF, TmpW, 2);
    TmpW := 24; FileWrite(HandleF, TmpW, 2);
    TmpC := 0; FileWrite(HandleF, TmpC, 4);
    TmpC := Img.Largeur * Img.Hauteur * 3; FileWrite(HandleF, TmpC, 4);
    TmpC := 3780; FileWrite(HandleF, TmpC, 4); FileWrite(HandleF, TmpC, 4);
    TmpC := 0; FileWrite(HandleF, TmpC, 4); FileWrite(HandleF, TmpC, 4);

    Larg := (Img.Largeur * Img.Palette);
    If Larg Mod 32 <> 0 Then Larg := Larg + 32 - Larg Mod 32;
    Larg := Larg Div 8;

    i := 0; j := 0;
    Repeat
    	tailleEcrit := 0;
      For k := 1 To Passe Div 3 Do
      Begin
        Couleur := Img.Pix[j, Img.Hauteur - i - 1];
        Buffer[(i * Img.Largeur * 3 + j * 3 + 2) Mod Passe] := GetRValue(Couleur);
        Buffer[(i * Img.Largeur * 3 + j * 3 + 1) Mod Passe] := GetGValue(Couleur);
        Buffer[(i * Img.Largeur * 3 + j * 3 + 0) Mod Passe] := GetBValue(Couleur);
       	Inc(j); Inc(tailleEcrit, 3);
        If j >= Img.Largeur Then Begin j := 0; Inc(i); If @Progress <> nil Then Progress(Round(i * 100 / Img.Hauteur)) End;
        If i >= Img.Hauteur Then Break;
      End;
      FileWrite(HandleF, Buffer, tailleEcrit);
    Until i = Img.Hauteur;
  Finally FileClose(HandleF) End;
End;

//---------------------------------------------------------------------------------------------
// ChargerAllBMP
Procedure ChargerAllBMP(NomFichier: String; Var Img: sImage; Progress: TProgressEvent; Fichier: pFichier);
Const
	Passe = 1032;
Var
  BMP_HeaderSize: Integer;
  TailleF, HandleF, i, j, k, TailleLu: Integer;
  Buffer: Array[0..Passe - 1] Of Byte;
  Couleur: TColor;
  Palette: Array Of TColor;
  Larg, Pause: Integer;
  Offset: Integer;
  Buf: Array[0..3] Of Byte;
Label
	Ret;
Begin
  HandleF := FileOpen(NomFichier, fmOpenRead);
  Try Try
    TailleF := FileSeek(HandleF, 0, 2);
    FileSeek(HandleF, 0, 0);

    FileRead(HandleF, Buffer, 14);
    If (Buffer[0] <> Ord('B')) Or (Buffer[1] <> Ord('M')) Then Raise Erreur(Erreur);
    If (LireInt(Buffer, 2, 4) <> TailleF) Then Raise ERangeError.Create('');
    If (LireInt(Buffer, 6, 4) <> 0) Then Raise Erreur(Erreur);
    FileRead(HandleF, BMP_HeaderSize, 4);
    FileRead(HandleF, Img.Largeur, 4);
    FileRead(HandleF, Img.Hauteur, 4);
    FileRead(HandleF, Buffer, BMP_HeaderSize - 12);
    If LireInt(Buffer, 0, 2) <> 1 Then Raise Erreur(Erreur);
    Img.Palette := LireInt(Buffer, 2, 2);
    Img.nbCouleurs := Round(IntPower(2, Img.Palette));
    For i := 4 To 7 Do If Buffer[i] <> 0 Then Raise Erreur(Erreur);
    For i := 20 To 23 Do If Buffer[i] <> 0 Then Raise Erreur(Erreur);
    SetLength(Img.Pix, Img.Largeur, Img.Hauteur);
    Larg := (Img.Largeur * Img.Palette);
    If Larg Mod 32 <> 0 Then Larg := Larg + 32 - Larg Mod 32;
    Larg := Larg Div 8;

		If Fichier <> nil Then
    Begin
    	Fichier.Nom := ExtractFileName(NomFichier);
		  Fichier.Format := 'Image BMP Windows';
	    Fichier.Taille := TailleF;
    End;

    If Img.Palette <= 8 Then
    Begin
	    SetLength(Palette, Img.nbCouleurs);
      FileRead(HandleF, Buffer, Img.nbCouleurs * 4);
      For i := 0 To Img.nbCouleurs Do
      	Palette[i] := RGB(Buffer[i * 4 + 2], Buffer[i * 4 + 1], Buffer[i * 4]);
    End;

    i := 0; j := 0; Pause := 0; Buf[0] := 0;
    Repeat
    	TailleLu := FileRead(HandleF, Buffer, Passe); k := 0;

      If (Buf[0] = 1) Or (Buf[0] = 2) Then
      Begin
      	If Buf[0] = 1 Then Buf[2] := Buffer[(i * Larg + j * 3 + 1) Mod Passe];
        Buf[3] := Buffer[(i * Larg + j * 3 + 2) Mod Passe];
        Couleur := RGB(Buf[3], Buf[2], Buf[1]);
        Inc(k, (3 - Buf[0]) * 8); Buf[0] := 0;
        Goto Ret;
    	End;

      While (k + Img.Palette) <= TailleLu * 8 Do
      Begin
      	If Pause <> 0 Then Begin Dec(Pause); Inc(k); Continue End;
      	Case Img.Palette Of
	        24: Couleur := RGB(Buffer[(i * Larg + j * 3 + 2) Mod Passe],
							               Buffer[(i * Larg + j * 3 + 1) Mod Passe],
						                 Buffer[(i * Larg + j * 3 + 0) Mod Passe]);
	        8: Couleur := Palette[Buffer[(i * Larg + j) Mod Passe]];
	        4: Begin Offset := (j Mod 2) * 4;
          Couleur := Palette[LireBits(4, Offset, Buffer[(i * Larg + j Div 2) Mod Passe])] End;
	        1: Begin Offset := (j Mod 8);
          Couleur := Palette[LireBit(Buffer[(i * Larg + j Div 8) Mod Passe], Offset)] End;
        End;

        Inc(k, Img.Palette);
       Ret:
        Img.Pix[j, Img.Hauteur - i - 1] := Couleur;
       	Inc(j);
        If j >= Img.Largeur Then
        Begin
        	j := 0; Inc(i);
          Pause := Larg * 8 - Img.Largeur * Img.Palette;
          If @Progress <> nil Then Progress(Round(i * 100 / Img.Hauteur))
        End;
        If i >= Img.Hauteur Then Break;
      End;
      If (Img.Palette = 24) Then If (k + 8) = TailleLu * 8 Then Begin Buf[0] := 1; Buf[1] := Buffer[1031] End
      Else If (k + 16) = TailleLu * 8 Then Begin Buf[0] := 2; Buf[1] := Buffer[1030]; Buf[2] := Buffer[1031] End;
    Until TailleLu <> Passe;

  Except
  	On Erreur Do ShowMessage('Ce format n''est pas support');
    Else ShowMessage('Il s''est produit une erreur');
  End;
  Finally Sleep(10); FileClose(HandleF) End;
End;

//---------------------------------------------------------------------------------------------
// ChargerAllBMP2
Procedure ChargerAllBMP2(NomFichier: String; Var iecBmpH, iecBmpW, iecSize, iecNbC : Integer; Var Image : PixGrid);
Const
	Passe = 1032;
Var
  BMP_HeaderSize: Integer;
  TailleF, HandleF, i, j, k, TailleLu: Integer;
  Buffer: Array[0..Passe - 1] Of Byte;
  Couleur: TColor;
  Palette: Array Of TColor;
  Larg, Pause: Integer;
  Offset: Integer;
  Buf: Array[0..3] Of Byte;
  Pix : PixGrid;
  PaletteJ, Hauteur, Largeur, nbCouleurs : Integer;
Label
	Ret;
Begin
  HandleF := FileOpen(NomFichier, fmOpenRead);
  Try Try
    TailleF := FileSeek(HandleF, 0, 2); iecSize := TailleF;
    FileSeek(HandleF, 0, 0);

    FileRead(HandleF, Buffer, 14);
    If (Buffer[0] <> Ord('B')) Or (Buffer[1] <> Ord('M')) Then Raise Erreur(Erreur);
    If (LireInt(Buffer, 2, 4) <> TailleF) Then Raise ERangeError.Create('');
    If (LireInt(Buffer, 6, 4) <> 0) Then Raise Erreur(Erreur);
    FileRead(HandleF, BMP_HeaderSize, 4);
    FileRead(HandleF, Largeur, 4); iecBmpW := Largeur;
    FileRead(HandleF, Hauteur, 4); iecBmpH := Hauteur;
    FileRead(HandleF, Buffer, BMP_HeaderSize - 12);
    If LireInt(Buffer, 0, 2) <> 1 Then Raise Erreur(Erreur);
    PaletteJ := LireInt(Buffer, 2, 2);   iecNBc := PaletteJ;
    nbCouleurs := Round(IntPower(2, PaletteJ));
    For i := 4 To 7 Do If Buffer[i] <> 0 Then Raise Erreur(Erreur);
    For i := 20 To 23 Do If Buffer[i] <> 0 Then Raise Erreur(Erreur);
    SetLength(Pix, Largeur, Hauteur);
    Larg := (Largeur * PaletteJ);
    If Larg Mod 32 <> 0 Then Larg := Larg + 32 - Larg Mod 32;
    Larg := Larg Div 8;

    If PaletteJ <= 8 Then
    Begin
	    SetLength(Palette, nbCouleurs);
      FileRead(HandleF, Buffer, nbCouleurs * 4);
      For i := 0 To nbCouleurs Do
      	Palette[i] := RGB(Buffer[i * 4 + 2], Buffer[i * 4 + 1], Buffer[i * 4]);
    End;

    i := 0; j := 0; Pause := 0; Buf[0] := 0;
    Repeat
    	TailleLu := FileRead(HandleF, Buffer, Passe); k := 0;

      If (Buf[0] = 1) Or (Buf[0] = 2) Then
      Begin
      	If Buf[0] = 1 Then Buf[2] := Buffer[(i * Larg + j * 3 + 1) Mod Passe];
        Buf[3] := Buffer[(i * Larg + j * 3 + 2) Mod Passe];
        Couleur := RGB(Buf[3], Buf[2], Buf[1]);
        Inc(k, (3 - Buf[0]) * 8); Buf[0] := 0;
        Goto Ret;
    	End;

      While (k + PaletteJ) <= TailleLu * 8 Do
      Begin
      	If Pause <> 0 Then Begin Dec(Pause); Inc(k); Continue End;
      	Case PaletteJ Of
	        24: Couleur := RGB(Buffer[(i * Larg + j * 3 + 2) Mod Passe],
							               Buffer[(i * Larg + j * 3 + 1) Mod Passe],
						                 Buffer[(i * Larg + j * 3 + 0) Mod Passe]);
	        8: Couleur := Palette[Buffer[(i * Larg + j) Mod Passe]];
	        4: Begin Offset := (j Mod 2) * 4;
          Couleur := Palette[LireBits(4, Offset, Buffer[(i * Larg + j Div 2) Mod Passe])] End;
	        1: Begin Offset := (j Mod 8);
          Couleur := Palette[LireBit(Buffer[(i * Larg + j Div 8) Mod Passe], Offset)] End;
        End;

        Inc(k, PaletteJ);
       Ret:
        Pix[j, Hauteur - i - 1] := Couleur;
       	Inc(j);
        If j >= Largeur Then
        Begin
          j := 0; Inc(i);
          Pause := Larg * 8 - Largeur * PaletteJ;
        End;
        If i >= Hauteur Then Break;
      End;
      If (PaletteJ = 24) Then If (k + 8) = TailleLu * 8 Then Begin Buf[0] := 1; Buf[1] := Buffer[1031] End
      Else If (k + 16) = TailleLu * 8 Then Begin Buf[0] := 2; Buf[1] := Buffer[1030]; Buf[2] := Buffer[1031] End;
    Until TailleLu <> Passe;

  Except
  	On Erreur Do ShowMessage('Ce format n''est pas support');
    Else ShowMessage('Il s''est produit une erreur');
  End;
  Finally Sleep(10); Image := Pix; FileClose(HandleF); End;
End;

// ErrorMessage ----- ///////
Procedure ErrorMessage(Info : String);
Begin
MessageDLG(Info, mtError, [mbOk], 0);
End;

end.
