unit uLzw;
// interface LZW

(*
 TPE 2001-2002
 DODANE Jean-Baptiste, ROUSSILLON Cyril  TS3
 Lyce Xavier Marmier, PONTARLIER

 Pour toute question, vous pouvez nous contacter :
   Jean-Baptiste (LZW, RLE) : jb@jbdsoftware.fr.st
   Cyril (JPEG, prdictif)  : cyril@crtek.fr.st
   
 Les TPE complets sont disponibles  l'adresse :
   www.chez.com/itek
 Ou sur nos sites personnels :
   www.jbdsoftware.fr.st
   www.crteknologies.fr.st
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, _bibliotheque, ComCtrls, _WTPE, math;

type
  TfmLZW = class(TForm)
    OpenDialog1: TOpenDialog;
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Button2: TButton;
    Panel2: TPanel;
    Label2: TLabel;
    Edit3: TEdit;
    Button5: TButton;
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    GroupBox3: TGroupBox;
    RadioCompression: TRadioGroup;
    CompressPanel: TPanel;
    DecompressPanel: TPanel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label3: TLabel;
    Label5: TLabel;
    ComboSizeDico: TComboBox;
    ComboPacksC: TComboBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Label7: TLabel;
    ComboPacksD: TComboBox;
    GroupBox2: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    FileSize: TLabel;
    FileType: TLabel;
    ListBox1: TListBox;
    GroupBox4: TGroupBox;
    Label4: TLabel;
    LabelC: TLabel;
    Label6: TLabel;
    LabelB: TLabel;
    ProgressBar1: TProgressBar;
    Button3: TButton;
    Label10: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure RadioCompressionClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    Procedure CDCFill;
    Procedure CommonEnd;
  public
    { Dclarations publiques }
  end;

Const
  dFilename : String = 'C:\WINDOWS\Profiles\JB\Bureau\TPE\Temp.txt';

var
  fmLZW: TfmLZW;
  LZW1 : dicLZW;
  CDC : CDCType;

implementation

{$R *.DFM}


procedure TfmLZW.RadioCompressionClick(Sender: TObject);
begin
Case RadioCompression.ItemIndex of
     0 : Begin
         Label1.Caption := 'Fichier  compresser :';
         Label2.Caption := 'Enregistr le fichier WTPE sous :';
         Button1.Show;
         Button3.Hide;
         CompressPanel.Show;
         DecompressPanel.Hide;
         End;
     1 : Begin
         Label1.Caption := 'Fichier  dcompresser :';
         Label2.Caption := 'Enregistr le fichier restaur sous :';
         Button1.Hide;
         Button3.Show;
         CompressPanel.Hide;
         DecompressPanel.Show;
         End;
End; {of case}
end;

Procedure TfmLZW.CDCFill;
Var FH : Integer;
    Ext : String;
Begin
CDC.Compression := not Boolean(RadioCompression.ItemIndex);
If CDC.Compression then Begin
                        CDC.Packs := StrToIntDef(ComboPacksC.Text, 4096);
                        CDC.ProgressBar := CheckBox1.Checked;
                        CDC.Messages := CheckBox2.Checked;
                        End
                   else Begin
                        CDC.Packs := StrToIntDef(ComboPacksD.Text, 4096);
                        CDC.ProgressBar := CheckBox3.Checked;
                        CDC.Messages := CheckBox4.Checked;
                        End;
CDC.File1 := Edit1.Text;
CDC.File2 := Edit3.Text;

If FileExists(CDC.File1) then Begin
                              FH := FileOpen(CDC.File1, 0);
                              CDC.FileSize := FileSeek(FH, 0, 2);
                              FileClose(FH);
                              FileSize.Caption := IntToStr(CDC.FileSize);

                              Ext := UpperCase(ExtractFileExt(CDC.File1));
                              If (Ext = '.TXT') or (Ext = '.DOC') or (Ext = '.RTF') or (Ext = '.HTM') then CDC.FileType := 'Document Texte' else
                              If (Ext = '.BMP') or (Ext = '.JPG') or (Ext = '.GIF') or (Ext = '.TIF') then CDC.FileType := 'Image' else
                              If (Ext = '.EXE') or (Ext = '.COM') or (Ext = '.BAT') or (Ext = '.SCR') then CDC.FileType := 'Fichier excutable' else
                              If (Ext = '.ZIP') or (Ext = '.RAR') or (Ext = '.WTP') or (Ext = '.PDF') then CDC.FileType := 'Fichier compress' else
                              CDC.FileType := 'Extension inconnue';
                              FileType.Caption := CDC.FileType;
                              End;
End;

///--// Button Start Procedures --- BEGIN //--///

procedure TfmLZW.Button1Click(Sender: TObject);
begin
CDCFill;

CDC.FileDico := Round(Power(2, ComboSizeDico.ItemIndex)) * 1024;
If Edit3.Text = '' then Begin ErrorMessage('Vous n''avez pas spcifi de fichier de sortie'); Exit; End;

ListBox1.Clear;
ListBox1.Items.Add('Informations :');
ListBox1.Items.Add('');

CDC.StartTime := Now;
CDC.Ratio := LZW1.FileComp(CDC.File1, CDC.File2, CDC);

CommonEnd;
end;

procedure TfmLZW.Button3Click(Sender: TObject);
begin
CDCFill;

If UpperCase(Copy(Edit1.Text, Length(Edit1.Text) - 3, 4)) <> 'WTPE' then Begin ErrorMessage('Le fichier d''entre n''est pas un fichier WTPE'); Exit; End;
If Edit3.Text = '' then Begin ErrorMessage('Vous n''avez pas spcifi de fichier de sortie'); Exit; End;

ListBox1.Clear;
ListBox1.Items.Add('Informations :');
ListBox1.Items.Add('');

CDC.StartTime := Now;
CDC.Ratio := LZW1.FileDeComp(CDC.File1, CDC.File2, CDC);

CommonEnd;
end;

///--// Button Start Procedures --- END //--///

///--// Edit File & Browse Procedures --- BEGIN //--///

procedure TfmLZW.Edit1Change(Sender: TObject);
begin
If FileExists(Edit1.Text) then Try CDCFill; Button1.Enabled := True; Button3.Enabled := True Except End else Try Button1.Enabled := False; Button3.Enabled := False; FileSize.Caption := '_____'; FileType.Caption := '_____'; Except; End;
end;

procedure TfmLZW.Button2Click(Sender: TObject);
begin
If OpenDialog1.Execute then Edit1.Text := OpenDialog1.Filename;
end;

procedure TfmLZW.Button5Click(Sender: TObject);
begin
If SaveDialog1.Execute then Edit3.Text := SaveDialog1.Filename;
If FileExists(Edit3.Text) then ShowMessage('Attention ! Ce fichier existe dja !');
end;

///--// Edit File & Browse Procedures --- END //--///


Procedure TfmLZW.CommonEnd;
Var Hour, Min, Sec, Msec : Word;
Begin
DecodeTime(CDC.EndTime - CDC.StartTime, Hour, Min, Sec, Msec);
LabelB.Caption := IntToStr(60000 * Min + 1000 * Sec + MSec) + ' ms.';
LabelC.Caption := IntToStr(CDC.Ratio) + '%';
Sleep(5);

Beep;    
End;

procedure TfmLZW.FormCreate(Sender: TObject);
begin
ComboSizeDico.ItemIndex := 2;
ComboPacksC.ItemIndex := 2;
ComboPacksD.ItemIndex := 2;
end;

end.
